%define _jarsign_opts --nocopy
%if "%{?rhel}" == "6"
%bcond_without zip
%else
%bcond_with zip
%endif

%define reltag GA
%define namedversion %{name}-%{version}.%{reltag}

Name: mod_snmp
Summary: mod_snmp is an apache httpd module
Version: 2.4.1
Release: 9.%{reltag}%{?dist}
License: GPL

#svn export http://svn.devel.redhat.com/repos/jboss-jon/tags/JBossON_2_4_1_GA/etc/product_connectors/apache-snmp/sources/
#mv sources mod_snmp-2.4.1.GA
#cp mod_snmp-2.4.1.GA/snmp_common/ucd-snmp/config.{sub,guess} mod_snmp-2.4.1.GA/snmp2.0/
#tar czf mod_snmp-2.4.1.GA.tgz mod_snmp-2.4.1.GA
Source0: %{namedversion}.tgz
Source1: mod_snmp.conf
Source2: %{name}.te
Patch0: mod_snmp-2.4.1.GA-bz826124.patch

Group: Development/Libraries

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL7
ExcludeArch: i386 i686 ppc64
%endif

BuildRequires: perl
BuildRequires: libtool

%if "%{?rhel}" == "7"
BuildRequires: httpd22-devel
%else
BuildRequires: httpd-devel
%endif

BuildRequires: zip
#For SELinux
%if "%{?rhel}" == "6"
BuildRequires: selinux-policy
%else
#%{_datadir}/selinux/devel/Makefile is in -devel on RHEL 5
BuildRequires: selinux-policy-devel
%endif

%if "%{?rhel}" == "5"
Requires(post): policycoreutils
Requires(postun): policycoreutils
%else
### same Requiries for RHEL 6 and 7
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python
%endif

%if "%{?rhel}" == "7"
Requires: httpd22
%else
Requires: httpd
%endif

%description
mod_snmp is an apache httpd module. With mod_snmp you can map SNMP OID's into State's 
value tree. You define basic structure of the State value tree and for each node you 
place a simple OID inside.

%if %with zip
%package src-zip
Summary:     Container for the source distribution of mod_rt
Group:       Development

%description src-zip
Container for the source distribution of mod_rt.
%endif

%prep
%setup -q -n %{namedversion}
%patch0

#Create src zip to include any patches
%if %with zip
zip -q -r %{name}-%{version}-src.zip *
%endif

%build
%if "%{?rhel}" == "7"
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs22}}
%else
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%endif

%if "%{?rhel}" == "7"
pushd ./snmp_common/libsmi
automake --add-missing || true
popd
%endif

%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%if "%{?rhel}" == "7"
./build_apache_snmp.sh 2.2 `which apxs22`
%else
./build_apache_snmp.sh 2.2 `which apxs`
%endif

%install
%if "%{?rhel}" == "7"
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs22}}
%else
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs}}
%endif

%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
rm -rf $RPM_BUILD_ROOT
%if "%{?rhel}" == "7"
mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd22/modules/ \
         $RPM_BUILD_ROOT%{_sysconfdir}/httpd22/conf.d \
%else
mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules/ \
         $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d \
%endif

mv snmp_module_2.2/module/libsnmpcommon.so snmp_module_2.2/module/snmpcommon.so 
mv snmp_module_2.2/module/libsnmpmonagt.so snmp_module_2.2/module/snmpmonagt.so 
mv snmp_module_2.2/module/libsnmpsubagt.so snmp_module_2.2/module/snmpsubagt.so 

%if "%{?rhel}" == "7"
install -p -m 755 snmp_module_2.2/module/snmp*.so \
    $RPM_BUILD_ROOT%{_libdir}/httpd22/modules/

install -p -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd22/conf.d/mod_snmp.conf
%else
install -p -m 755 snmp_module_2.2/module/snmp*.so \
    $RPM_BUILD_ROOT%{_libdir}/httpd/modules/

install -p -m 644 %{SOURCE1} \
        $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_snmp.conf
%endif
                                                                                                    
%if %with zip
mkdir -p $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
cp %{name}-%{version}-src.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

# for SELinux
install -d -m 755 $RPM_BUILD_ROOT/%{_localstatedir}/cache/mod_snmp
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}
mkdir selinux
pushd selinux
cp -p %{SOURCE2} .
touch %{name}.fc %{name}.if
make -f %{_datadir}/selinux/devel/Makefile
install -p -m 644 -D %{name}.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}/%{name}.pp
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ $1 -eq 1 ] ; then
/sbin/restorecon -Fr %{aplibdir} 2>/dev/null || :
%{_sbindir}/semanage fcontext -a -t httpd_cache_t '/var/cache/mod_snmp(/.*)?' >/dev/null 2>&1 || :
/sbin/restorecon -R /var/cache/mod_snmp >/dev/null 2>&1 || :
%{_sbindir}/semodule -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 2>/dev/null || :
fi

%preun
if [ $1 -eq 0 ] ; then
%{_sbindir}/semodule -r mod_snmp 2>&1 || :
fi
%files
%defattr(-,root,root,-)
%if "%{?rhel}" == "7"
%config(noreplace) %{_sysconfdir}/httpd22/conf.d/mod_snmp.conf
%{_libdir}/httpd22/modules/*.so
%else
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_snmp.conf
%{_libdir}/httpd/modules/*.so
%endif
# for SELinux
%dir %{_localstatedir}/cache/mod_snmp
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/%{name}.pp

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Tue Apr 08 2014 Weinan Li <weli@redhat.com> - 0:2.4.1-9.GA
- Migrate to RHEL7

* Fri Sep 07 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.4.1-8.GA
- Fix SELinux R: on RHEL 6

* Mon Aug 20 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.4.1-7.GA
- Add SELinux policy

* Mon Aug 20 2012 Weinan Li <weli@redhat.com> - 0:2.4.1-6.GA
- Add mod_snmp-2.4.1.GA-bz826124.patch 

* Tue Jun 19 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.4.1-5.GA
- Create src.zip at the end of prep

* Tue May 01 2012 Weinan Li <weli@redhat.com> - 0:2.4.1-4.GA
- Rename libsnmp*.so to snmp*.so
- Modify mod_snmp.conf according to the rename

* Mon Apr 30 2012 Weinan Li <weli@redhat.com> - 0:2.4.1-3.GA
- Fix mod_snmp.conf 

* Thu Apr 26 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.4.1-2.GA
- Add src-zip subpackage
- Fix Version and Release: tags

* Mon Jan 09 2012 Weinan Li <weli@redhat.com> - 0:2.4.1.GA-1
Initial import
